/*****************************************/
/*****************************************/
/**               LIST                  **/
/**                                     **/
/** Generic list implementation         **/
/**                                     **/
/** Copyright (c) 2008                  **/
/**     Stefan Stattelmann              **/
/**                                     **/
/** Author:                             **/
/**     Stefan Stattelmann              **/
/**                                     **/
/** Contact:                            **/
/**     s9ststat@stud.uni-saarland.de   **/
/*****************************************/
/*****************************************/
#ifndef _LIST_
#define _LIST_

/************/
/* Includes */
/************/
#include <stdlib.h>

/**************/
/* Structures */
/**************/

typedef struct LIST_HELP {
    struct LIST_HELP *tail;
    void             *data;
} LIST_NODE;

typedef LIST_NODE *LIST;

/**************************************************************/
/**************************************************************/
/*  This is the structure to implement linked lists where     */
/*     tail  rest of the list, possibly NULL                  */
/*     data  holds the content of the current list node       */
/**************************************************************/
/**************************************************************/


/**************/
/* Functions  */
/**************/

void    list_Init (void);
void    list_Free (void);

LIST    list_Create  (void *);
LIST    list_Prepend (void *, LIST);
void*   list_Head (LIST);
LIST    list_Tail (LIST);
int     list_Nil (LIST);
void    list_NodeFree (LIST, int);
void    list_Delete (LIST, int);
LIST    list_Concat (LIST, LIST);

#endif

