/*****************************************/
/*****************************************/
/**             MAIN                    **/
/**                                     **/
/** Main module                         **/
/**                                     **/
/** Copyright (c) 2008                  **/
/**     Stefan Stattelmann              **/
/**                                     **/
/** Author:                             **/
/**     Stefan Stattelmann              **/
/**                                     **/
/** Contact:                            **/
/**     s9ststat@stud.uni-saarland.de   **/
/*****************************************/
/*****************************************/

#include "main.h"

/***************/
/*  Functions  */
/***************/

int main (int argc, char** argv)
/**************************************************************
 SUMMARY:   one CNF file is allowed as argument which will then
            be parsed and (hopefully) solved
***************************************************************/
{
    int res = 0;
    CLAUSES set;

    /* only one argument allowed */
    if (argc != 2 || (argc == 2 && argv[1][0] == '-' && argv[1][1] == 'h'))
    {
        fprintf (stderr, "Usage: SAT <CNF File>\n");
        return 1;
    }

    set = clauses_Parse (argv[1]);

    if (set)
    {
        int sat;

        sat = clauses_Solve (set);

        if (sat)
        {
            printf ("satisfiable");

            clauses_PrintValuation (set, stdout);
            clauses_Delete (set);

            printf ("\n");
        }
        else 
            printf ("unsatisfiable\n");
    }
    else
    {
        /* indicate failure in return value, error message has already
           been printed somewhere else */
        res = 1;
    }

    return res;
}

